build.sh 7.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186
  1. #!/bin/bash
  2. # (c) 2014-2015 Helge Jung <hej@c3pb.de>
  3. #
  4. # This script is controlled by environment variables, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # SITE = specific site repository commit-id (leave blank to use HEAD)
  10. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  11. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  12. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  13. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  14. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  15. #
  16. function get_all_supported_platforms()
  17. {
  18. local buffer;
  19. for val in $(ls ${1}) ; do
  20. [ -d "./${1}/${val}" ] || continue
  21. buffer="${buffer} ${val}"
  22. done
  23. echo ${buffer}
  24. }
  25. if [ "_$BRANCH" == "_" ]; then
  26. echo "Please specify BRANCH environment variable." >&2
  27. exit 1
  28. fi
  29. if [ "_$BASE" == "_" ]; then
  30. echo "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)." >&2
  31. exit 1
  32. fi
  33. if [ "_$VERSION" == "_" -a "$BRANCH" != "experimental" ]; then
  34. echo "Please specify VERSION environment variable (not necessary for experimental branch)." >&2
  35. exit 1
  36. fi
  37. MY_DIR=$(dirname $0)
  38. MY_DIR=$(readlink -f "$MY_DIR")
  39. CODE_DIR="src"
  40. OUTPUT_DIR="${MY_DIR}/output"
  41. BUILD_INFO_FILENAME="build-info.txt"
  42. VERSIONS_INFO_DIR="versions"
  43. pushd $MY_DIR > /dev/null
  44. [ "_$BUILD_TS" == "_" ] && export BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  45. . functions.sh
  46. ### CHECK THAT VERSION DOES NOT YET EXISTS
  47. [ -n "$VERSION" -a -x "versions/${VERSION}" ] && abort "There exists a version file for '$VERSION' ... you are trying to do something really stupid, aren't you?"
  48. ### INIT /src IF NECESSARY
  49. if [ ! -d "$CODE_DIR" ]; then
  50. info "Code directory does not exist yet - fetching Gluon ..."
  51. git clone https://github.com/freifunk-gluon/gluon.git "$CODE_DIR"
  52. fi
  53. ### INIT /src/site IF NECESSARY
  54. if [ ! -d "$CODE_DIR/site" ]; then
  55. info "Site repository does not exist, fetching it ..."
  56. git clone https://git.c3pb.de/freifunk-pb/site-ffpb.git "$CODE_DIR/site"
  57. fi
  58. ### CHECKOUT GLUON
  59. progress "Checking out GLUON '$BASE' ..."
  60. cd $CODE_DIR
  61. # TODO: check if gluon got modified and bail out if necessary
  62. git fetch ; git checkout -q $BASE
  63. [ "$?" -eq "0" ] || abort "Failed to checkout '$BASE' gluon base version, mimimi." >&2
  64. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  65. ### CHECKOUT SITE REPO
  66. progress "Checking out SITE REPO ..."
  67. cd site
  68. # TODO: check if site got modified locally and bail out if necessary
  69. if [ "_$SITE" == "_" ]; then
  70. # no specific site given - get the most current one
  71. git checkout -q $BRANCH ; git pull
  72. [ "$?" -eq "0" ] || abort "Failed to get newest '$BRANCH' in site repository, mimimi."
  73. else
  74. # commit given - use this one
  75. git checkout -q $SITE || abort "Failed to checkout requested site commit, mimimi."
  76. fi
  77. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  78. cd ..
  79. ### CLEAN
  80. if [ "$BRANCH" != "experimental" ]; then
  81. progress "Cleaning your build environment ..."
  82. make dirclean
  83. fi
  84. ### PREPARE
  85. progress "Preparing the build environment (make update) ..."
  86. make update
  87. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  88. # we are now ready to produke the firmware images, so let's "save" our state
  89. build_info_path="${OUTPUT_DIR}/${BRANCH}/${BUILD_INFO_FILENAME}"
  90. progress "Saving build information to: ${build_info_path}"
  91. mkdir -p $(dirname ${build_info_path})
  92. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  93. touch $(dirname ${build_info_path})
  94. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  95. echo "VERSION=${VERSION}" >> ${build_info_path}
  96. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  97. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  98. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  99. echo "TS=${BUILD_TS}" >> ${build_info_path}
  100. ### BUILD FIRMWARE
  101. progress "Building the firmware - please stand by!"
  102. [ -n "${BROKEN}" ] || BROKEN=0
  103. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  104. [ -n "${TARGETS}" ] || TARGETS=$(get_all_supported_platforms "./targets")
  105. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  106. default_release_pattern=$( awk -F" := " '/^DEFAULT_GLUON_RELEASE/ { gsub("shell ", "", $2); print $2; }' ./site/site.mk )
  107. VERSION=$(eval echo ${default_release_pattern})
  108. fi
  109. for target in ${TARGETS} ; do
  110. # configure build environment for our current target
  111. export GLUON_TARGET="${target}"
  112. gluon_build_env_vars="GLUON_TARGET=\"${target}\" GLUON_BRANCH=\"${BRANCH}\" GLUON_RELEASE=\"${VERSION}\" BROKEN=\"${BROKEN}\""
  113. # prepare build environment for our current target
  114. progress "Preparing build environment for target ${target}."
  115. [ "${BRANCH}" == "experimental" ] || make clean
  116. make -j ${MAKEJOBS} prepare-target
  117. # need to have a toolchain for the particular target
  118. progress "Building toolchain for target ${target}."
  119. make -j ${MAKEJOBS} toolchain/install
  120. [ "$?" -eq "0" ] || abort "Unable to build toolchain for target. Aborting."
  121. # now we can start building the images for the target platform
  122. progress "Building FFPB-flavoured Gluon firmware for target ${target}. You'd better go and fetch some c0ffee!"
  123. make_targets="prepare"
  124. eval "${gluon_build_env_vars} faketime \"$BUILD_TS\" make -j ${MAKEJOBS} ${make_targets}"
  125. [ "$?" -eq "0" ] || abort "Failed to build firmware for target-platform ${target}."
  126. # finally compile the firmware binaries
  127. progress "Compiling binary firmware images."
  128. faketime "$BUILD_TS" make images
  129. [ "$?" -eq "0" ] || abort "Failed to assemble images for target-platform ${target}."
  130. done
  131. cd ..
  132. # compress all binaries into 7z archive
  133. progress "Assembling images.7z ..."
  134. [ -e "output/${BRANCH}/images.7z" ] && rm "output/${BRANCH}/images.7z"
  135. 7z a "output/${BRANCH}/images.7z" ${CODE_DIR}/images/sysupgrade/*.bin ${CODE_DIR}/images/factory/*.bin || abort "Failed to assemble images (did you install p7zip-full?)."
  136. # generate, franken-merge, and copy manifests
  137. progress "Generating and copying manifest ..."
  138. pushd $CODE_DIR
  139. for target in ${TARGETS} ; do
  140. GLUON_TARGET="${target}" GLUON_BRANCH=$BRANCH make manifest || abort "Failed to generate the manifest, try running 'make manifest' in '$CODE_DIR' directory manually."
  141. mv ./images/sysupgrade/${BRANCH}.manifest ./images/sysupgrade/${target}.${BRANCH}.manifest
  142. done
  143. frankenmerge_manifest_file="./images/sysupgrade/${BRANCH}.manifest"
  144. echo "BRANCH=${BRANCH}" > ${frankenmerge_manifest_file}
  145. echo "DATE=${BUILD_TS}" >> ${frankenmerge_manifest_file}
  146. echo "PRIORITY=0" >> ${frankenmerge_manifest_file}
  147. echo "" >> ${frankenmerge_manifest_file}
  148. grep -hE "*.bin$" ./images/sysupgrade/*.${BRANCH}.manifest | sort >> ${frankenmerge_manifest_file}
  149. popd
  150. cp "${CODE_DIR}/images/sysupgrade/${BRANCH}.manifest" "output/${BRANCH}/"
  151. # Saving a copy of the build info file as reference
  152. progress "Building a greater and brighter firmware finished successfully. Saving build information at: ${VERSIONS_INFO_DIR}/${VERSION}"
  153. cp -p "${build_info_path}" "${VERSIONS_INFO_DIR}/${VERSION}"
  154. # The end. Finally.
  155. success "We're done, go and enjoy your new firmware in ${OUTPUT_DIR}/${BRANCH}!"
  156. popd > /dev/null